import { Base, INotifyPropertyChanged, IEnumerable, Type, PropertyChangedEventArgs } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { IDomainChartWidget } from "./IDomainChartWidget";
import { XamDataChart } from "./XamDataChart";
import { DataSeriesAdapterImplementation } from "igniteui-angular-core";
import { DataSeriesType } from "igniteui-angular-core";
import { IDataSeriesAdapterRule } from "igniteui-angular-core";
import { MarkerType } from "./MarkerType";
import { IAnnotationLayerProxy } from "./IAnnotationLayerProxy";
import { Color } from "igniteui-angular-core";
import { BrushCollection } from "igniteui-angular-core";
import { IChartLegend } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { HorizontalAlignment } from "igniteui-angular-core";
import { UnknownValuePlotting } from "igniteui-angular-core";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { MarkerTypeCollection } from "./MarkerTypeCollection";
import { TrendLineType } from "igniteui-angular-core";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { ToolTipType } from "./ToolTipType";
import { CrosshairsDisplayMode } from "./CrosshairsDisplayMode";
import { Series } from "./Series";
import { DataSeries } from "igniteui-angular-core";
import { ObservableColorCollection } from "igniteui-angular-core";
import { DataSeriesMarker } from "igniteui-angular-core";
import { ChartSeriesEventArgs } from "./ChartSeriesEventArgs";
import { DomainChartSeriesPointerEventArgs } from "./DomainChartSeriesPointerEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
/**
 * @hidden
 */
export declare abstract class DomainChart extends Base implements INotifyPropertyChanged {
    static $t: Type;
    protected er: any;
    provideContainer(a: any): void;
    destroy(): void;
    private ib;
    protected ic(): void;
    protected h8(a: XamDataChart): void;
    protected h5(): void;
    protected ie(a: Series, b: number): void;
    protected i0(a: string, b: any, c: any): void;
    private eq;
    get tooltipTemplate(): any;
    set tooltipTemplate(a: any);
    private cp;
    get tooltipTemplates(): List$1<any>;
    set tooltipTemplates(a: List$1<any>);
    private da;
    get dy(): number;
    set dy(a: number);
    private ep;
    private get toolTip();
    private set toolTip(value);
    private dn;
    get eb(): number;
    set eb(a: number);
    private dp;
    get ec(): number;
    set ec(a: number);
    private dq;
    get ed(): number;
    set ed(a: number);
    private dm;
    get ea(): number;
    set ea(a: number);
    private di;
    get d6(): number;
    set d6(a: number);
    private dk;
    get d8(): number;
    set d8(a: number);
    private dj;
    get d7(): number;
    set d7(a: number);
    private dh;
    get d5(): number;
    set d5(a: number);
    private jt;
    get j0(): Brush;
    set j0(a: Brush);
    private ju;
    get j1(): Brush;
    set j1(a: Brush);
    private c8;
    protected get_dw(): number;
    protected set_dw(a: number): void;
    get dw(): number;
    set dw(a: number);
    private dr;
    get ee(): number;
    set ee(a: number);
    private dg;
    get d4(): number;
    set d4(a: number);
    private c7;
    get dv(): number;
    set dv(a: number);
    private ek;
    get en(): number;
    set en(a: number);
    private bj;
    get bk(): (time: number) => number;
    set bk(a: (time: number) => number);
    protected h9(a: XamDataChart): void;
    protected ig(a: Series, b: number): void;
    protected h6(): void;
    private ih;
    eg: (arg1: HTMLElement) => any[];
    private jn;
    private et;
    private ck;
    private eh;
    protected i1(a: string, b: any, c: any): void;
    private am;
    get an(): IDomainChartWidget;
    set an(a: IDomainChartWidget);
    private e5;
    get g2(): string;
    set g2(a: string);
    private e7;
    get hd(): string;
    set hd(a: string);
    private bh;
    get dataChart(): XamDataChart;
    set dataChart(a: XamDataChart);
    ac: DataSeriesAdapterImplementation;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    constructor();
    protected ia(): void;
    protected abstract get cv(): List$1<DataSeriesType>;
    protected abstract get cu(): List$1<IDataSeriesAdapterRule>;
    protected ct: List$1<MarkerType>;
    protected cg(a: DataSeriesType): boolean;
    notifyResized(): void;
    iq(): void;
    h0(): void;
    h3(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected i6(a: string): void;
    protected h1(a: (arg1: Series) => void): void;
    protected h2(a: (arg1: Series, arg2: number) => void): void;
    protected is(a: (arg1: XamDataChart) => void): void;
    protected it(a: (arg1: XamDataChart) => void, b: boolean): void;
    protected iu(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    protected ch(a: DataSeries): boolean;
    protected cb(): boolean;
    private static readonly ez;
    private ej;
    protected f0(a: DataSeries): string;
    private static ey;
    protected f1(a: DataSeries, b: DataSeriesType): string;
    protected abstract ab(a: DataSeries): DataSeriesType;
    protected abstract a3(a: DataSeries, b: DataSeriesType): Series;
    fz(): string;
    private ce;
    protected jh(): void;
    protected a4(seriesType_: DataSeriesType): Series;
    private ay;
    private a0;
    private a1;
    private a2;
    private az;
    private ai;
    protected get aj(): IAnnotationLayerProxy;
    private get b9();
    private ca;
    private jo;
    protected cr(a: string, b: boolean): List$1<Series>;
    protected jm(a: Series, b: Series, c: DataSeries): void;
    protected abstract jg(a: DataSeries): void;
    protected abstract jf(a: DataSeries): void;
    protected jj(): void;
    private jk;
    protected jl(a: Series): void;
    protected abstract ji(): void;
    private iv;
    protected hy(): void;
    protected jv(a: number): Brush;
    protected jy(a: number): Brush;
    protected jw(a: number): Brush;
    protected jx(a: number): Brush;
    protected j2(a: number): Color;
    protected bl(a: Color): ObservableColorCollection;
    protected o(a: Color): BrushCollection;
    protected co: List$1<Color>;
    protected get cq(): List$1<Color>;
    es(): any;
    ii(a: string, b: string): void;
    ij(a: string, b: string, c: Series): void;
    au(a: DataSeriesMarker): MarkerType;
    ip(source_: any, a: number, b: any, c: any): void;
    ik(source_: any): void;
    il(source_: any, a: number, b: any): void;
    im(source_: any, a: number, b: any): void;
    seriesAdded: (sender: any, args: ChartSeriesEventArgs) => void;
    i7(a: Series): void;
    seriesRemoved: (sender: any, args: ChartSeriesEventArgs) => void;
    jd(a: Series): void;
    seriesPointerEnter: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    i9(a: Series, b: any): void;
    seriesPointerLeave: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    ja(a: Series, b: any): void;
    seriesPointerMove: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    jb(a: Series, b: any): void;
    seriesPointerDown: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    i8(a: Series, b: any): void;
    seriesPointerUp: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    jc(a: Series, b: any): void;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    i5(a: any, b: CalloutStyleUpdatingEventArgs): void;
    private cs;
    i3(a: () => void): void;
    private bm;
    i4(a: () => void, b: boolean): {
        p1?: boolean;
    };
    protected get_ci(): boolean;
    protected get ci(): boolean;
    protected h7(a: XamDataChart): void;
    protected s(a: BrushCollection): BrushCollection;
    protected jz(a: Brush): Brush;
    protected id(a: Series, b: number): void;
    protected abstract hw(): void;
    protected get b3(): boolean;
    private bp;
    protected hz(): void;
    protected h4(): void;
    protected je(a: XamDataChart): void;
    private hv;
    protected abstract hu(a: Series, b: number): void;
    protected av(a: Series, b: number): MarkerType;
    protected c3(): IEnumerable;
    protected get_cc(): boolean;
    protected get cc(): boolean;
    protected c4(): IEnumerable;
    protected iz(a: string, b: any, c: any): void;
    private ix;
    private cz;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    private cx;
    get actualItemsSource(): IEnumerable;
    set actualItemsSource(a: IEnumerable);
    private b;
    get d(): string[];
    set d(a: string[]);
    private a;
    get c(): string[];
    set c(a: string[]);
    private g;
    get n(): BrushCollection;
    set n(a: BrushCollection);
    private j;
    get r(): BrushCollection;
    set r(a: BrushCollection);
    private e;
    get l(): BrushCollection;
    set l(a: BrushCollection);
    private f;
    get m(): BrushCollection;
    set m(a: BrushCollection);
    private ak;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    private bv;
    protected get_cd(): boolean;
    protected set_cd(a: boolean): void;
    get cd(): boolean;
    set cd(a: boolean);
    private bx;
    protected get_cj(): boolean;
    protected set_cj(a: boolean): void;
    get cj(): boolean;
    set cj(a: boolean);
    private bz;
    protected get_cm(): boolean;
    protected set_cm(a: boolean): void;
    get cm(): boolean;
    set cm(a: boolean);
    private b0;
    protected get_cn(): boolean;
    protected set_cn(a: boolean): void;
    get cn(): boolean;
    set cn(a: boolean);
    private bw;
    protected get_cf(): boolean;
    protected set_cf(a: boolean): void;
    get cf(): boolean;
    set cf(a: boolean);
    private j3;
    get j5(): Rect;
    set j5(a: Rect);
    get j4(): Rect;
    private e6;
    get g6(): string;
    set g6(a: string);
    private e4;
    get gv(): string;
    set gv(a: string);
    private jq;
    get js(): HorizontalAlignment;
    set js(a: HorizontalAlignment);
    private jp;
    get jr(): HorizontalAlignment;
    set jr(a: HorizontalAlignment);
    private bf;
    get bg(): UnknownValuePlotting;
    set bg(a: UnknownValuePlotting);
    private df;
    protected get_d3(): number;
    protected set_d3(a: number): void;
    get d3(): number;
    set d3(a: number);
    private dl;
    get d9(): number;
    set d9(a: number);
    private a9;
    get ba(): SeriesOutlineMode;
    set ba(a: SeriesOutlineMode);
    private as;
    get at(): MarkerOutlineMode;
    set at(a: MarkerOutlineMode);
    private aq;
    get ar(): MarkerFillMode;
    set ar(a: MarkerFillMode);
    private c9;
    get dx(): number;
    set dx(a: number);
    private aw;
    get ax(): MarkerTypeCollection;
    set ax(a: MarkerTypeCollection);
    private h;
    get p(): BrushCollection;
    set p(a: BrushCollection);
    private i;
    get q(): BrushCollection;
    set q(a: BrushCollection);
    private ei;
    get em(): number;
    set em(a: number);
    private bo;
    get b2(): boolean;
    set b2(a: boolean);
    private k;
    get t(): BrushCollection;
    set t(a: BrushCollection);
    private bd;
    get be(): TrendLineType;
    set be(a: TrendLineType);
    private ds;
    get ef(): number;
    set ef(a: number);
    private bn;
    get b1(): boolean;
    set b1(a: boolean);
    private dc;
    get d0(): number;
    set d0(a: number);
    private de;
    get d2(): number;
    set d2(a: number);
    private dd;
    get d1(): number;
    set d1(a: number);
    private db;
    get dz(): number;
    set dz(a: number);
    protected iy(): void;
    private x;
    get y(): ComputedPlotAreaMarginMode;
    set y(a: ComputedPlotAreaMarginMode);
    private a7;
    get a8(): SeriesHighlightingMode;
    set a8(a: SeriesHighlightingMode);
    private a5;
    get a6(): SeriesHighlightingBehavior;
    set a6(a: SeriesHighlightingBehavior);
    private ao;
    get ap(): LegendHighlightingMode;
    set ap(a: LegendHighlightingMode);
    private by;
    get cl(): boolean;
    set cl(a: boolean);
    private c5;
    get dt(): number;
    set dt(a: number);
    private c6;
    get du(): number;
    set du(a: number);
    private el;
    get eo(): number;
    set eo(a: number);
    private bb;
    get bc(): ToolTipType;
    set bc(a: ToolTipType);
    private z;
    get aa(): CrosshairsDisplayMode;
    set aa(a: CrosshairsDisplayMode);
    private bt;
    get b7(): boolean;
    set b7(a: boolean);
    private bs;
    get b6(): boolean;
    set b6(a: boolean);
    private bu;
    get b8(): boolean;
    set b8(a: boolean);
    private br;
    get b5(): boolean;
    set b5(a: boolean);
    private bq;
    get b4(): boolean;
    set b4(a: boolean);
    private cy;
    get calloutsItemsSource(): IEnumerable;
    set calloutsItemsSource(a: IEnumerable);
    private e2;
    get fo(): string;
    set fo(a: string);
    private e3;
    get fq(): string;
    set fq(a: string);
    private e1;
    get fk(): string;
    set fk(a: string);
    private e0;
    get fh(): string;
    set fh(a: string);
}
